<launch>

    <!-- global arguments are only defined here -->
    <arg name="vehicle1_id" value="1" />
    <arg name="vehicle2_id" value="2" />
    <arg name="pedestrian1_id" value="5" />
    <arg name="pedestrian2_id" value="6" />

    <arg name="objects_ground_truth_topic_with_ns" value="/sim/objects_ground_truth" />
    <arg name="desired_motion_topic_with_ns" value="/sim/desired_motion" />
    <arg name="object_initialization_topic_with_ns" value="/sim/object_initialization" />
    <arg name="object_removal_topic_with_ns" value="/sim/object_removal" />
    <arg name="global_communication_ns" value="/sim/comm" />
	<arg name="reset_object_pose_topic" value="/sim/reset_object_pose" />
	<arg name="clear_queue_topic" value="/sim/clear_comm_queue" />

    <arg name="perc_pred_obj_topic" value="perceived_objects" />
    <arg name="perc_egomotion_topic" value="ego_motion_state" />
    <arg name="pred_plan_obj_topic" value="predicted_objects" />
    <arg name="internal_communication_subns" value="comm" />

    <arg name="BSM_topic" default="BSM"/>

    <arg name="lanelet_map_filename" value="$(find simulation_initialization_ros_tool)/res/intersection.osm" />
    <arg name="lanelet_lane_1" value="$(find simulation_initialization_ros_tool)/res/intersection_lane_1.osm" />
    <arg name="lanelet_lane_2" value="$(find simulation_initialization_ros_tool)/res/intersection_lane_2.osm" />
    <arg name="utm_base_frame" default="map"/>
    <arg name="loc_mgmt_frame" default="$(arg utm_base_frame)"/>
    <arg name="map_center_lat" value="49.0229515" />
    <arg name="map_center_lon" value="8.4318737" />
    <arg name="map_center_frame" value="lanelet_map_center" />

    <!-- implicit definitions "$(arg )" -->
    <arg name="vehicle1_ns" value="v$(arg vehicle1_id)" />
    <arg name="vehicle2_ns" value="v$(arg vehicle2_id)" />
    <arg name="pedestrian1_ns" value="p$(arg pedestrian1_id)" />
    <arg name="pedestrian2_ns" value="p$(arg pedestrian2_id)" />

    <!-- rosparameter definitions -->
    <param name="/use_sim_time" value="true" />
    <param name="/time_mgmt/acc_factor" value="1" />
    <param name="/time_mgmt/time_resolution" value="1000" />
    <param name="/localization_mgmt/loc_mgmt_freq" value="100"/>

    <!-- set true for a synchronized start (you start the time by unclicking "pause_time" in the dynamic reconfigure window) -->
    <param name="/time_mgmt/pause_time" value="false" />

    <param name="/ll_rviz/lanelet_map_filename" value="$(arg lanelet_map_filename)"/>
    <param name="/ll_rviz/map_center_lat" value="$(arg map_center_lat)"/>
    <param name="/ll_rviz/map_center_lon" value="$(arg map_center_lon)"/>
    <param name="/ll_rviz/map_center_frame" value="$(arg map_center_frame)"/>


    <!-- set logger level -->
    <env name="ROSCONSOLE_CONFIG_FILE"
         value="$(find simulation_initialization_ros_tool)/launch/custom_rosconsole.conf"/>

    <!-- Define point instead of comma as decimal seperator -->
    <env name="LC_NUMERIC"
              value="en_US.UTF-8"/>

    <!-- launch simulation management -->
    <include file="$(find simulation_management_ros_tool)/launch/simulation_management.launch">
        <arg name="objects_ground_truth_topic_with_ns" value="$(arg objects_ground_truth_topic_with_ns)" />
        <arg name="desired_motion_topic_with_ns" value="$(arg desired_motion_topic_with_ns)" />
        <arg name="object_initialization_topic_with_ns" value="$(arg object_initialization_topic_with_ns)" />
        <arg name="object_removal_topic_with_ns" value="$(arg object_removal_topic_with_ns)" />
        <arg name="fixed_frame" value="$(arg loc_mgmt_frame)" />
		<arg name="reset_object_pose_topic" value="$(arg reset_object_pose_topic)" />
    </include>

    <!-- launch objects -->
    <include file="$(find simulation_initialization_ros_tool)/launch/vehicle_launchfiles/sample_vehicle.launch" ns="$(arg vehicle1_ns)" >
        <arg name="vehicle_id" value="$(arg vehicle1_id)" />
        <arg name="vehicle_ns" value="$(arg vehicle1_ns)" />

        <arg name="objects_ground_truth_topic_with_ns" value="$(arg objects_ground_truth_topic_with_ns)" />
        <arg name="desired_motion_topic_with_ns" value="$(arg desired_motion_topic_with_ns)" />
        <arg name="global_communication_ns" value="$(arg global_communication_ns)" />
        <arg name="perc_pred_obj_topic" value="$(arg perc_pred_obj_topic)" />
        <arg name="perc_egomotion_topic" value="$(arg perc_egomotion_topic)" />
        <arg name="pred_plan_obj_topic" value="$(arg pred_plan_obj_topic)" />
        <arg name="internal_communication_subns" value="$(arg internal_communication_subns)" />
        <arg name="BSM_topic" value="$(arg BSM_topic)" />
		<arg name="slow_down_topic" value="slowDown1" />
        <arg name="lanelet_map_filename" value="$(arg lanelet_lane_1)" />

        <arg name="object_initialization_topic_with_ns" value="$(arg object_initialization_topic_with_ns)" />
        <arg name="trajectory_file" value="$(find simulation_initialization_ros_tool)/res/traj1.osm" />
        <arg name="initial_v" value="5" />
        <arg name="hull_file" value="$(find simulation_initialization_ros_tool)/res/sample_hull.xml" />
        <arg name="object_type" value="car" />
        <arg name="s_start" value="0.0" />
        <arg name="frame_id_initial_position" value="$(arg utm_base_frame)" />
        <arg name="frame_id_loc_mgmt" value="$(arg loc_mgmt_frame)" />
	    <arg name="clear_queue_topic" value="$(arg clear_queue_topic)" />
    </include>

    <include file="$(find simulation_initialization_ros_tool)/launch/vehicle_launchfiles/sample_vehicle.launch" ns="$(arg vehicle2_ns)" >
        <arg name="vehicle_id" value="$(arg vehicle2_id)" />
        <arg name="vehicle_ns" value="$(arg vehicle2_ns)" />

        <arg name="objects_ground_truth_topic_with_ns" value="$(arg objects_ground_truth_topic_with_ns)" />
        <arg name="desired_motion_topic_with_ns" value="$(arg desired_motion_topic_with_ns)" />
        <arg name="global_communication_ns" value="$(arg global_communication_ns)" />
        <arg name="perc_pred_obj_topic" value="$(arg perc_pred_obj_topic)" />
        <arg name="perc_egomotion_topic" value="$(arg perc_egomotion_topic)" />
        <arg name="pred_plan_obj_topic" value="$(arg pred_plan_obj_topic)" />
        <arg name="internal_communication_subns" value="$(arg internal_communication_subns)" />
        <arg name="BSM_topic" value="$(arg BSM_topic)" />
		<arg name="slow_down_topic" value="slowDown2" />
        <arg name="lanelet_map_filename" value="$(arg lanelet_lane_2)" />

        <arg name="object_initialization_topic_with_ns" value="$(arg object_initialization_topic_with_ns)" />
        <arg name="trajectory_file" value="$(find simulation_initialization_ros_tool)/res/traj2.osm" />
        <arg name="initial_v" value="5" />
        <arg name="hull_file" value="$(find simulation_initialization_ros_tool)/res/sample_hull.xml" />
        <arg name="object_type" value="car" />
        <arg name="s_start" value="0.0" />
        <arg name="frame_id_initial_position" value="$(arg utm_base_frame)" />
        <arg name="frame_id_loc_mgmt" value="$(arg loc_mgmt_frame)" />
	    <arg name="clear_queue_topic" value="$(arg clear_queue_topic)" />
    </include>

    <!--include file="$(find simulation_initialization_ros_tool)/launch/vehicle_launchfiles/sample_static_obstacle.launch" ns="$(arg pedestrian1_ns)" >
        <arg name="vehicle_id" value="$(arg pedestrian1_id)" />
        <arg name="vehicle_ns" value="$(arg pedestrian1_ns)" />

        <arg name="object_initialization_topic_with_ns" value="$(arg object_initialization_topic_with_ns)" />
        <arg name="trajectory_file" value="$(find simulation_initialization_ros_tool)/res/traj3.osm" />
        <arg name="hull_file" value="$(find simulation_initialization_ros_tool)/res/sample_hull_pedestrian.xml" />
        <arg name="object_type" value="pedestrian" />
        <arg name="s_start" value="0.0" />
        <arg name="frame_id_initial_position" value="$(arg utm_base_frame)" />
        <arg name="frame_id_loc_mgmt" value="$(arg loc_mgmt_frame)" />
    </include-->

    <!--include file="$(find simulation_initialization_ros_tool)/launch/vehicle_launchfiles/sample_dynamic_obstacle.launch" ns="$(arg pedestrian2_ns)" >
        <arg name="vehicle_id" value="$(arg pedestrian2_id)" />
        <arg name="vehicle_ns" value="$(arg pedestrian2_ns)" />

        <arg name="object_initialization_topic_with_ns" value="$(arg object_initialization_topic_with_ns)" />
        <arg name="trajectory_file" value="$(find simulation_initialization_ros_tool)/res/traj3.osm" />
        <arg name="initial_v" value="2.0" />
        <arg name="hull_file" value="$(find simulation_initialization_ros_tool)/res/sample_hull_pedestrian.xml" />
        <arg name="object_type" value="pedestrian" />
        <arg name="s_start" value="5.0" />
        <arg name="frame_id_initial_position" value="$(arg utm_base_frame)" />
        <arg name="frame_id_loc_mgmt" value="$(arg loc_mgmt_frame)" />
    </include-->

    <!--include file="$(find simulation_management_ros_tool)/launch/object_removal.launch" ns="$(arg pedestrian1_ns)" >
        <arg name="object_id" value="$(arg pedestrian1_id)" />
        <arg name="time_of_removal_walltime" value="20" />
        <arg name="object_removal_topic_with_ns" value="$(arg object_removal_topic_with_ns)" />
    </include-->



    <!-- publish the tf from the base frame to the map center (used as fixed frame in rviz) -->
    <include file="$(find simulation_utils_ros_tool)/launch/static_utm_tf_publisher.launch" >
        <arg name="tf_publisher_name" value="transform_utm_base_to_map_center_publisher" />
        <arg name="child_lat" value="$(arg map_center_lat)" />
        <arg name="child_lon" value="$(arg map_center_lon)" />
        <arg name="tf_frame_id_utm_base" value="$(arg utm_base_frame)" />
        <arg name="tf_frame_id_child" value="$(arg map_center_frame)" />
        <arg name="publishing_frequency" value="100.0" />
    </include>

    <!-- publish nav-sat-fix for satellite images in rviz -->
    <include file="$(find simulation_utils_ros_tool)/launch/nav_sat_fix_launchfile_publisher.launch" >
        <arg name="publisher_name" value="nav_sat_fix_map_center_publisher" />
        <arg name="frame_lat" value="$(arg map_center_lat)" />
        <arg name="frame_lon" value="$(arg map_center_lon)" />
        <arg name="frame_alt" value="0.0" />
        <arg name="tf_frame_id" value="$(arg map_center_frame)" />
        <arg name="nav_sat_fix_topic" value="nav_sat_fix_map_center" />
        <arg name="publishing_frequency" value="1" />
    </include>

    <!-- start rviz -->
    <node pkg="rviz" type="rviz" name="my_rviz" args="-d $(find simulation_initialization_ros_tool)/launch/simulation_framework.rviz" output="screen" />

    <!-- start rqt reconfigure -->
    <node pkg="rqt_reconfigure" name="rqt_reconfigure" type="rqt_reconfigure" >
    </node>

    <!--node pkg="emam_converter" name="converter" type="converter" output="screen"/-->
	<include file="$(find emam_converter)/launch/emam_converter.launch">
	    <arg name="abs_trajectory_topic_template" value="/ba_system_intersectionController_trajectoryIn_{i}_"/>
		<arg name="delta_time_topic_template" value="/ba_system_velocityController_{i}__deltaTimeIn" />
		<arg name="collision_hulls_topic_template" value="ba_system_collisionDetection_hulls_{i}_" />
		<arg name="current_velocity_topic_template" value="/ba_system_curVel_{i}_" />
		<arg name="ground_truth_topic" value="$(arg objects_ground_truth_topic_with_ns)" />
		<arg name="desired_motion_topic" value="$(arg desired_motion_topic_with_ns)" />
	    <arg name="clear_queue_topic" value="$(arg clear_queue_topic)" />
	</include>

	<include file="$(find experiment_manager)/launch/experiment_manager.launch" >
	    <arg name="ground_truth_topic" value="$(arg objects_ground_truth_topic_with_ns)"/>
		<arg name="collision_topic" value="ba_system_collisionOut"/>
		<arg name="reset_object_pose_topic" value="$(arg reset_object_pose_topic)"/>
		<arg name="controller_active_topic" value="/ba_system_intersectionController_isActive"/>
		<arg name="cutoff_time_topic" value="ba_system_intersectionController_cutoffTime"/>
		<arg name="max_vel_topic_template" value="ba_system_velocityController_{i}__maxVelIn"/>
		<arg name="max_accel_topic_template" value="ba_system_velocityController_{i}__maxAccelIn"/>
		<arg name="reset_vel_topic_template" value="ba_system_velocityController_{i}__resetVelIn"/>
		<arg name="hold_time_topic_template" value="ba_system_velocityController_{i}__holdTimeIn"/>
		<arg name="trajectory_topic_template" value="ba_system_intersectionController_trajectoryIn_{i}_" />
		<arg name="experiments_configs_file" value="$(find experiment_manager)/res/10ExpConfigs.csv"/>
		<arg name="environment_configs_file" value="$(find experiment_manager)/res/demonstrationEnvConfigs.csv"/>
		<arg name="results_file" value="$(find experiment_manager)/output/demoResults.csv"/>
		<arg name="clear_queue_topic" value="$(arg clear_queue_topic)" />
	</include>

</launch>
